//---------------------------------------------------------------------------
#ifndef ChatEdit1H
#define ChatEdit1H
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class PACKAGE TChatEdit : public TPaintBox
{
private:
protected:
TStringList *FLines;
TStringList *DisplayLines;

TFont *FFont;
TScrollBar *FScrollBar;
TColor FBkColor,FTextColor1,FTextColor2,FTextColor3,FTextColor4,FTextColor5;
unsigned int FPosition;
int FNrLines;
Graphics::TBitmap *Smilies;
AnsiString FSmiliesFile;
virtual void __fastcall Paint(void);
void __fastcall SetBkColor(TColor);
void __fastcall SetTextColor1(TColor);
void __fastcall SetTextColor2(TColor);
void __fastcall SetTextColor3(TColor);
void __fastcall SetTextColor4(TColor);
void __fastcall SetTextColor5(TColor);
void __fastcall SetFont(TFont *);
void __fastcall SetPosition(unsigned int);
int __fastcall GetNrLines();
void __fastcall ResetCanvas();
void __fastcall SetScrollBar(TScrollBar *);
virtual void __fastcall Loaded(void);
void __fastcall ProcessDisplay();
public:
    __fastcall TChatEdit(TComponent* Owner);
    void __fastcall AddLines(TStringList *);
    void __fastcall AddLine(AnsiString);
    void __fastcall Clear();
    void __fastcall LoadSmilies();
    int __fastcall TextWidth(AnsiString);
__published:
__property TScrollBar * ScrollBar={read=FScrollBar,write=SetScrollBar,default=NULL};
__property int NrLines = {read=GetNrLines};
__property TFont * Font={read=FFont,write=SetFont,stored=true};
__property unsigned int Position={read=FPosition,write=SetPosition};
__property TColor BkColor={read=FBkColor,write=SetBkColor};
__property TColor TextColor1={read=FTextColor1,write=SetTextColor1};
__property TColor TextColor2={read=FTextColor2,write=SetTextColor2};
__property TColor TextColor3={read=FTextColor3,write=SetTextColor3};
__property TColor TextColor4={read=FTextColor4,write=SetTextColor4};
__property TColor TextColor5={read=FTextColor5,write=SetTextColor5};
__property AnsiString SmiliesFile={read=FSmiliesFile,write=FSmiliesFile};
};
//---------------------------------------------------------------------------
#endif
